diff --git a/build.gradle.kts b/build.gradle.kts
index d0f6e8c30..39f707195 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -138,6 +138,15 @@ task("runClient", JavaExec::class) {
     systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
 }
 
+task("runColorizerGenerator", JavaExec::class) {
+    dependsOn(tasks["copyNatives"])
+    group = "bta"
+    mainClass.set("net.betterthanadventure.utils.ColorizerGenerator")
+    classpath = sourceSets["main"].runtimeClasspath
+
+    systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
+}
+
 java {
     sourceCompatibility = JavaVersion.VERSION_1_8
     targetCompatibility = JavaVersion.VERSION_1_8
diff --git a/src/main/java/net/betterthanadventure/utils/ColorizerGenerator.java b/src/main/java/net/betterthanadventure/utils/ColorizerGenerator.java
new file mode 100644
index 000000000..d2c6d8583
--- /dev/null
+++ b/src/main/java/net/betterthanadventure/utils/ColorizerGenerator.java
@@ -0,0 +1,112 @@
+package net.betterthanadventure.utils;
+import net.minecraft.core.util.helper.Color;
+import org.lwjgl.opengl.Display;
+import org.lwjgl.opengl.DisplayMode;
+import static org.lwjgl.opengl.GL11.*;
+
+public class ColorizerGenerator {
+
+    // Desert = 0.749, 0.718, 0.333
+    // Cold = 0.502, 0.706, 0.592
+    // Midpoint = 0.486, 0.741, 0.42
+    // Temperate = 0.278, 0.804, 0.2
+
+    private static float getFloatColor(int color){
+        return (float) color / 255F;
+    }
+    // Summer
+//        static int colorColdI = 0x80b497;
+//        static int colorMidI = 0x7cbd6b;
+//        static int colorTemperateI = 0x47cd33;
+//        static int colorDryI = 0xbfb755;
+
+    //Fall
+//        static int colorColdI = 0x85b088;
+//        static int colorMidI = 0xafbb5d;
+//        static int colorTemperateI = 0x8bc540;
+//        static int colorDryI = 0xbfb755;
+
+    // Winter
+//    static int colorColdI = 0x93b5ac;
+//    static int colorMidI = 0x81b496;
+//    static int colorTemperateI = 0xb0aa72;
+//    static int colorDryI = 0x8cc047;
+
+    static int colorColdI = 0x85be9e;
+    static int colorMidI = 0x82c96f;
+    static int colorTemperateI = 0x4bde36;
+    static int colorDryI = 0x8cc047;
+
+    static Color colorCold = new Color().setARGB(colorColdI);
+    static Color colorMid = new Color().setARGB(colorMidI);
+    static Color colorTemperate = new Color().setARGB(colorTemperateI);
+    static Color colorDry = new Color().setARGB(colorDryI);
+    private static void drawVertex(Color color){
+        glColor3d(getFloatColor(color.getRed()), getFloatColor(color.getGreen()), getFloatColor(color.getBlue()));
+    }
+    public static void main(String[] args) throws Exception {
+        Display.setDisplayMode(new DisplayMode(257, 257));
+        Display.setTitle("Gradient");
+        Display.create();
+        Display.setVSyncEnabled(true);
+
+
+
+        while(!Display.isCloseRequested()) {
+            glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
+            glClear(GL_COLOR_BUFFER_BIT);
+            glLoadIdentity();
+            glOrtho(0, 1, 0, 1, -1, 1);
+
+            System.out.println(colorCold.getRed());
+
+            // Originals
+//            glBegin(GL_TRIANGLES);
+//
+//            glColor3d(0.749, 0.718, 0.333);
+//            glVertex2d(0.0, 0.0);
+//
+//            glColor3d(0.278, 0.804, 0.2);
+//            glVertex2d(0.0, 1.0);
+//
+//            glColor3d(0.486, 0.741, 0.42);
+//            glVertex2d(0.5, 0.5);
+//            glColor3d(0.749, 0.718, 0.333);
+//            glVertex2d(0.0, 0.0);
+//
+//            glColor3d(0.486, 0.741, 0.42);
+//            glVertex2d(0.5, 0.5);
+//
+//            glColor3d(0.502, 0.706, 0.592);
+//            glVertex2d(1.0, 0.0);
+//
+//            glEnd();
+
+            glBegin(GL_TRIANGLES);
+
+            // tri 1
+            drawVertex(colorDry);
+            glVertex2d(0.0, 0.0);
+
+            drawVertex(colorTemperate);
+            glVertex2d(0.0, 1.0);
+
+            drawVertex(colorMid);
+            glVertex2d(0.5, 0.5);
+
+            // tri 2
+            drawVertex(colorDry);
+            glVertex2d(0.0, 0.0);
+
+            drawVertex(colorMid);
+            glVertex2d(0.5, 0.5);
+
+            drawVertex(colorCold);
+            glVertex2d(1.0, 0.0);
+
+            glEnd();
+
+            Display.update();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 1165821aa..e6df39416 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -396,8 +396,13 @@ public class Minecraft
         BiomeProviderOverworld.init();
 
         ColorizerWater.updateColorData(renderEngine.getTextureImageData("/misc/watercolor.png"));
-        ColorizerGrass.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor.png"));
+        ColorizerGrass.defaultColor.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor.png"));
+        ColorizerGrass.spring.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor_spring.png"));
+        ColorizerGrass.summer.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor.png"));
+        ColorizerGrass.fall.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor_fall.png"));
+        ColorizerGrass.winter.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor_winter.png"));
         ColorizerFoliage.updateColorData(renderEngine.getTextureImageData("/misc/foliagecolor.png"));
+
         worldRenderer = new WorldRenderer(this);
 
         // I hate initialization issues so much
diff --git a/src/main/java/net/minecraft/client/render/RenderEngine.java b/src/main/java/net/minecraft/client/render/RenderEngine.java
index 989e6590a..30d703bd6 100644
--- a/src/main/java/net/minecraft/client/render/RenderEngine.java
+++ b/src/main/java/net/minecraft/client/render/RenderEngine.java
@@ -36,6 +36,8 @@ import net.minecraft.client.util.helper.Colors;
 import net.minecraft.client.util.helper.TexturePackJsonHelper;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.world.season.Seasons;
 
 import java.awt.image.BufferedImage;
 import java.io.IOException;
@@ -758,9 +760,13 @@ public class RenderEngine {
 		mc.mainMenuBackground.refresh(errors);
 		
         ColorizerWater.updateColorData(mc.renderEngine.getTextureImageData("/misc/watercolor.png"));
-        ColorizerGrass.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor.png"));
+		ColorizerGrass.defaultColor.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor.png"));
+		ColorizerGrass.spring.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor_spring.png"));
+		ColorizerGrass.summer.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor.png"));
+		ColorizerGrass.fall.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor_fall.png"));
+		ColorizerGrass.winter.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor_winter.png"));
         ColorizerFoliage.updateColorData(mc.renderEngine.getTextureImageData("/misc/foliagecolor.png"));
-        
+        ColorizerGrass.update(true);
         mc.worldRenderer.lightmapHelper.setup();
 	}
 
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 946e859dd..76eecae66 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render;
 import java.util.List;
 import java.util.Random;
 
+import net.minecraft.client.render.colorizer.ColorizerGrass;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
@@ -603,6 +604,7 @@ public class WorldRenderer
     	Debug.push("misc");
         RenderGlobal renderGlobal = mc.renderGlobal;
         EffectRenderer effectRenderer = mc.effectRenderer;
+        ColorizerGrass.update(false);
 
         GL11.glEnable(GL11.GL_CULL_FACE);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 9c50538b1..1ff86d6e8 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -29,15 +29,15 @@ public final class BlockColorDispatcher
         addDispatch(Block.leavesOak, new BlockColorLeavesOak());
         addDispatch(Block.leavesPine, new BlockColorLeaves("pine"));
         addDispatch(Block.leavesShrub, new BlockColorLeaves("shrub"));
-        addDispatch(Block.leavesCaatinga, new BlockColorLeaves("caatinga"));
+        addDispatch(Block.leavesThorn, new BlockColorLeaves("caatinga"));
         addDispatch(Block.leavesPalm, new BlockColorLeaves("palm"));
         addDispatch(Block.mossStone, new BlockColorGrass());
         addDispatch(Block.mossBasalt, new BlockColorGrass());
         addDispatch(Block.mossLimestone, new BlockColorGrass());
         addDispatch(Block.mossGranite, new BlockColorGrass());
         addDispatch(Block.wireRedstone, new BlockColorRedstoneWire());
-        addDispatch(Block.tallgrass, new BlockColorTallGrass());
-        addDispatch(Block.tallgrassFern, new BlockColorTallGrass());
+        addDispatch(Block.tallgrass, new BlockColorGrass());
+        addDispatch(Block.tallgrassFern, new BlockColorGrass());
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java
index 6a51cb2ca..ee3d07934 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorGrass.java
@@ -16,57 +16,13 @@ public class BlockColorGrass
     @Override
     public int getFallbackColor(int meta)
     {
-        return ColorizerGrass.getGrassColor(0.5, 0.5);
+        return ColorizerGrass.grassMap.getGrassColor(0.5, 0.5);
     }
 
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z)
-    {
+    public int getWorldColor(WorldSource world, int x, int y, int z) {
         double localTemperature = world.getBlockTemperature(x, z);
         double localHumidity = world.getBlockHumidity(x, z);
-        int baseGrassColor = ColorizerGrass.getGrassColor(localTemperature, localHumidity);
-        Season season = world.getSeasonManager().getCurrentSeason();
-        if (season != null)
-        {
-            boolean isWinter = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS);
-
-            float progress = world.getSeasonManager().getSeasonProgress();
-            if(isWinter){
-                baseGrassColor = ColorizerGrass.getGrassColor((localTemperature*progress), localHumidity);
-            }
-
-            baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress - 0.5f));
-
-            if(isWinter){
-                float offsetIntensity = 1 - Math.abs((progress) - 1);
-                float red = ((baseGrassColor & 0xFF0000) >> 16) / 255F;
-                float green = ((baseGrassColor & 0x00FF00) >> 8) / 255F;
-                float blue = (baseGrassColor & 0x0000FF) / 255F;
-
-                float gray = red * green * blue / 3;
-                float grayOffset = (float)grassColorPerlin.getValue(x / 30D, y / 30D, z / 30D) * offsetIntensity * 0.5f;
-                if (gray + grayOffset > 0.4f) grayOffset = 0.4f - gray;
-                if (gray + grayOffset < 0.0f) grayOffset = -gray;
-
-                red = ((red + grayOffset));
-                green = ((green + grayOffset));
-                blue = ((blue + grayOffset));
-
-                if (red < 0) red = 0;
-                if (red > 1) red = 1;
-                if (green < 0) green = 0;
-                if (green > 1) green = 1;
-                if (blue < 0) blue = 0;
-                if (blue > 1) blue = 1;
-
-                int newRed = (int) (red * 255) & 0xFF;
-                int newGreen = (int) (green * 255) & 0xFF;
-                int newBlue = (int) (blue * 255) & 0xFF;
-
-                baseGrassColor = ((newRed << 16) | (newGreen << 8) | (newBlue));
-
-            }
-        }
-        return baseGrassColor;
+        return ColorizerGrass.grassMap.getGrassColor(localTemperature, localHumidity);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index ab82b1af7..fc4131b05 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -29,76 +29,6 @@ public class BlockColorTallGrass
         localTemperature += offsetT;
         localHumidity += offsetH;
 
-        int baseGrassColor = ColorizerGrass.getGrassColor(localTemperature, localHumidity);
-        if (world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA || world.getBlockBiome(x, y - 1, z) == Biomes.OVERWORLD_CAATINGA_PLAINS) {
-
-            Season season = world.getSeasonManager().getCurrentSeason();
-            if (season != null) {
-                boolean ishumid = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS || season == Seasons.OVERWORLD_SPRING);
-                float progress = world.getSeasonManager().getSeasonProgress();
-
-                if (ishumid) {
-                    baseGrassColor = ColorizerGrass.getGrassColor(0.95, 0.78);
-                } else {
-                    baseGrassColor = ColorizerGrass.getGrassColor(0.95, 0.1);
-                }
-                baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress - 0.5f));
-            }
-            return baseGrassColor;
-        }
-
-        int blockBelow = world.getBlockId(x, y - 1, z);
-        if(blockBelow == Block.grassScorched.id || blockBelow == Block.dirtScorched.id || blockBelow == Block.dirtScorchedRich.id ){
-
-            return 0xffcc58;
-        }
-        Season season = world.getSeasonManager().getCurrentSeason();
-        if (season != null)
-        {
-
-            boolean isWinter = (season == Seasons.OVERWORLD_WINTER || season == Seasons.OVERWORLD_WINTER_ENDLESS);
-
-
-            float progress = world.getSeasonManager().getSeasonProgress();
-
-            if(isWinter){
-                baseGrassColor = ColorizerGrass.getGrassColor(localTemperature*progress, localHumidity);
-            }
-
-            baseGrassColor = season.modifyGrassColorizer(baseGrassColor, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress - 0.5f));
-
-            if(isWinter){
-                float offsetIntensity = 1 - Math.abs((progress*2F) - 1);
-                float red = ((baseGrassColor & 0xFF0000) >> 16) / 255F;
-                float green = ((baseGrassColor & 0x00FF00) >> 8) / 255F;
-                float blue = (baseGrassColor & 0x0000FF) / 255F;
-
-                float gray = red * green * blue / 3;
-                float grayOffset = (float)grassColorPerlin.getValue(x / 30D, y / 50D, z / 30D) * offsetIntensity * 0.5f;
-                if (gray + grayOffset > 0.4f) grayOffset = 0.4f - gray;
-                if (gray + grayOffset < 0.0f) grayOffset = -gray;
-
-                red = ((red + grayOffset));
-                green = ((green + grayOffset));
-                blue = ((blue + grayOffset));
-
-                if (red < 0) red = 0;
-                if (red > 1) red = 1;
-                if (green < 0) green = 0;
-                if (green > 1) green = 1;
-                if (blue < 0) blue = 0;
-                if (blue > 1) blue = 1;
-
-                int newRed = (int) (red * 255) & 0xFF;
-                int newGreen = (int) (green * 255) & 0xFF;
-                int newBlue = (int) (blue * 255) & 0xFF;
-
-
-                baseGrassColor = ((newRed << 16) | (newGreen << 8) | (newBlue));
-
-            }
-
-        }
-        return baseGrassColor;
+        return ColorizerGrass.defaultColor.getGrassColor(localTemperature, localHumidity);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 6e19ebf27..bf7c3ad7d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -53,6 +53,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Block.limestonePolished).withTextures("minecraft:block/polished_limestone_top", "minecraft:block/polished_limestone_side"));
         addDispatch(new BlockModelStandard<>(Block.basaltPolished).withTextures("minecraft:block/polished_basalt_top", "minecraft:block/polished_basalt_side"));
         addDispatch(new BlockModelStandard<>(Block.slatePolished).withTextures("minecraft:block/polished_slate_top", "minecraft:block/polished_slate_side"));
+        addDispatch(new BlockModelStandard<>(Block.permafrostPolished).withTextures("minecraft:block/polished_permafrost_top", "minecraft:block/polished_permafrost_side"));
 
         addDispatch(new BlockModelAxisAligned<>(Block.pillarMarble).withTextures("minecraft:block/pillar_marble_top", "minecraft:block/pillar_marble_side"));
         addDispatch(new BlockModelStandard<>(Block.capstoneMarble).withTextures("minecraft:block/capstone_marble_top", "minecraft:block/capstone_marble_side"));
@@ -63,6 +64,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Block.graniteCarved).withTextures("minecraft:block/polished_granite_top", "minecraft:block/carved_granite"));
         addDispatch(new BlockModelStandard<>(Block.limestoneCarved).withTextures("minecraft:block/polished_limestone_top", "minecraft:block/carved_limestone"));
         addDispatch(new BlockModelStandard<>(Block.basaltCarved).withTextures("minecraft:block/polished_basalt_top", "minecraft:block/carved_basalt"));
+        addDispatch(new BlockModelStandard<>(Block.permafrostCarved).withTextures("minecraft:block/polished_permafrost_top", "minecraft:block/carved_permafrost"));
 
         addDispatch(new BlockModelStandard<>(Block.planksOak).withTextures("minecraft:block/planks_oak"));
         addDispatch(new BlockModelPlanksPainted<>(Block.planksOakPainted));
@@ -117,6 +119,10 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelSlab<>(Block.slabGranitePolished));
         addDispatch(new BlockModelSlab<>(Block.slabLimestonePolished));
         addDispatch(new BlockModelSlab<>(Block.slabBasaltPolished));
+        addDispatch(new BlockModelSlab<>(Block.slabPermafrostPolished));
+        addDispatch(new BlockModelSlab<>(Block.slabCobblePermafrost));
+        addDispatch(new BlockModelSlab<>(Block.slabBrickSandstone));
+        addDispatch(new BlockModelSlab<>(Block.slabBrickPermafrost));
 
         addDispatch(new BlockModelStairs<>(Block.stairsPlanksOak));
         addDispatch(new BlockModelStairs<>(Block.stairsCobbleStone));
@@ -132,6 +138,10 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelStairsPainted<>(Block.stairsPlanksOakPainted));
         addDispatch(new BlockModelStairs<>(Block.stairsBrickSlate));
         addDispatch(new BlockModelStairs<>(Block.stairsBrickStone));
+        addDispatch(new BlockModelStairs<>(Block.stairsSandstone));
+        addDispatch(new BlockModelStairs<>(Block.stairsCobblePermafrost));
+        addDispatch(new BlockModelStairs<>(Block.stairsBrickSandstone));
+        addDispatch(new BlockModelStairs<>(Block.stairsBrickPermafrost));
 
         addDispatch(new BlockModelStandard<>(Block.obsidian).withTextures("minecraft:block/obsidian"));
 
@@ -176,7 +186,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelAxisAligned<>(Block.logCherry).withTextures("minecraft:block/log_cherry_top", "minecraft:block/log_cherry_side"));
         addDispatch(new BlockModelAxisAligned<>(Block.logEucalyptus).withTextures("minecraft:block/log_eucalyptus_top", "minecraft:block/log_eucalyptus_side"));
         addDispatch(new BlockModelAxisAligned<>(Block.logOakMossy).withTextures("minecraft:block/log_oak_mossy_top", "minecraft:block/log_oak_mossy_side"));
-        addDispatch(new BlockModelAxisAligned<>(Block.logThorn).withTextures("minecraft:block/log_brazilwood_top", "minecraft:block/log_brazilwood_side"));
+        addDispatch(new BlockModelAxisAligned<>(Block.logThorn).withTextures("minecraft:block/log_thorn_top", "minecraft:block/log_thorn_side"));
         addDispatch(new BlockModelAxisAligned<>(Block.logPalm).withTextures("minecraft:block/log_palm_top", "minecraft:block/log_palm_side"));
 
         addDispatch(new BlockModelLeaves<>(Block.leavesOak, "minecraft:block/leaves_oak"));
@@ -188,7 +198,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelLeaves<>(Block.leavesShrub, "minecraft:block/leaves_shrub"));
         addDispatch(new BlockModelCherryLeavesBloom<>(Block.leavesCherryFlowering));
         addDispatch(new BlockModelCacaoLeaves<>(Block.leavesCacao));
-        addDispatch(new BlockModelLeaves<>(Block.leavesCaatinga, "minecraft:block/leaves_caatinga"));
+        addDispatch(new BlockModelLeaves<>(Block.leavesThorn, "minecraft:block/leaves_caatinga"));
         addDispatch(new BlockModelLeaves<>(Block.leavesPalm, "minecraft:block/leaves_palm"));
 
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingOak).withTextures("minecraft:block/sapling_oak"));
@@ -199,7 +209,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingEucalyptus).withTextures("minecraft:block/sapling_eucalyptus"));
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingShrub).withTextures("minecraft:block/sapling_shrub"));
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingCacao).withTextures("minecraft:block/sapling_cacao"));
-        addDispatch(new BlockModelCrossedSquares<>(Block.saplingThorn).withTextures("minecraft:block/sapling_brazilwood"));
+        addDispatch(new BlockModelCrossedSquares<>(Block.saplingThorn).withTextures("minecraft:block/sapling_thorn"));
         addDispatch(new BlockModelCrossedSquares<>(Block.saplingPalm).withTextures("minecraft:block/sapling_palm"));
 
         addDispatch(new BlockModelCrossedSquares<>(Block.tallgrass).withTextures("minecraft:block/tallgrass"));
diff --git a/src/main/java/net/minecraft/client/render/colorizer/ColorizerGrass.java b/src/main/java/net/minecraft/client/render/colorizer/ColorizerGrass.java
index a3f41f2a3..a00534d69 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/ColorizerGrass.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/ColorizerGrass.java
@@ -1,36 +1,73 @@
 package net.minecraft.client.render.colorizer;
 
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.Seasons;
+
 public class ColorizerGrass
 {
-
+    private static Minecraft mc = Minecraft.getMinecraft(ColorizerGrass.class);
     public ColorizerGrass()
     {
     }
 
-    public static void updateColorData(int ai[])
-    {
-        grassBuffer = ai;
+    public static void update(boolean force){
+        World world = mc.theWorld;
+        if(world == null) {
+            lastTickWorld = null;
+            return;
+        }
+        Season season = world.getSeasonManager().getCurrentSeason();
+        int dayInSeason = world.seasonManager.getDayInSeason();
+        float progress = world.getSeasonManager().getSeasonProgress();
+        boolean update = force || lastTickWorld != world || lastTickSeason != season || lastTickDayInSeason != dayInSeason;
+        if(update) {
+            lastTickSeason = season;
+            lastTickDayInSeason = dayInSeason;
+            lastTickWorld = world;
+            if (season == null) {
+                grassMap.updateColorData(defaultColor.buffer);
+            } else {
+                updateColor(season, progress > 0.5f ? world.getSeasonManager().getNextSeason() : world.getSeasonManager().getPreviousSeason(), Math.abs(progress));
+            }
+        }
     }
 
-    public static int getGrassColor(double d, double d1)
-    {
-        if (d < 0.0D)
-            d = 0.0D;
-        else if(d > 1.0D)
-            d = 1.0D;
-        if (d1 < 0.0D)
-            d1 = 0.0D;
-        else if(d1 > 1.0D)
-            d1 = 1.0D;
-
-        d1 *= d;
-
-        int i = (int)((1.0D - d) * 255D);
-        int j = (int)((1.0D - d1) * 255D);
-        return grassBuffer[j << 8 | i];
+    private static void updateColor(Season season1, Season season2, float blend) {
+        GrassColorMap colormap1 = getSeasonalColorizer(season1);
+        GrassColorMap colormap2 = getSeasonalColorizer(season2);
+        int[] buffer1 = colormap1.buffer;
+        int[] buffer2 = colormap2.buffer;
+        int[] data = grassMap.buffer;
+
+        for(int i = 0; i < data.length; ++i) {
+            data[i] = Season.blendColors(buffer1[i], buffer2[i], blend);
+        }
     }
 
-    private static int grassBuffer[] = new int[0x10000];
+    private static GrassColorMap getSeasonalColorizer(Season season) {
+        if (season == Seasons.OVERWORLD_SPRING) {
+            return spring;
+        } else if (season == Seasons.OVERWORLD_SUMMER) {
+            return summer;
+        } else if (season == Seasons.OVERWORLD_FALL) {
+            return fall;
+        } else if (season == Seasons.OVERWORLD_WINTER) {
+            return winter;
+        } else {
+            return grassMap;
+        }
+    }
+    public static GrassColorMap defaultColor = new GrassColorMap();
+    public static GrassColorMap spring = new GrassColorMap();
+    public static GrassColorMap summer = new GrassColorMap();
+    public static GrassColorMap fall = new GrassColorMap();
+    public static GrassColorMap winter = new GrassColorMap();
+    public static GrassColorMap grassMap = new GrassColorMap();
+    private static World lastTickWorld;
+    private static Season lastTickSeason;
+    private static float lastTickDayInSeason;
 
 }
diff --git a/src/main/java/net/minecraft/client/render/colorizer/GrassColorMap.java b/src/main/java/net/minecraft/client/render/colorizer/GrassColorMap.java
new file mode 100644
index 000000000..a33b38607
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/colorizer/GrassColorMap.java
@@ -0,0 +1,31 @@
+package net.minecraft.client.render.colorizer;
+
+public class GrassColorMap {
+    public GrassColorMap()
+    {
+    }
+    public void updateColorData(int[] map)
+    {
+        buffer = map;
+    }
+
+    public int getGrassColor(double temp, double humid)
+    {
+        if (temp < 0.0D)
+            temp = 0.0D;
+        else if(temp > 1.0D)
+            temp = 1.0D;
+        if (humid < 0.0D)
+            humid = 0.0D;
+        else if(humid > 1.0D)
+            humid = 1.0D;
+
+        humid *= temp;
+
+        int x = (int)((1.0D - temp) * 255D);
+        int y = (int)((1.0D - humid) * 255D);
+        return buffer[y << 8 | x];
+    }
+
+    public int[] buffer = new int[0x10000];
+}
